package shcm.shsupercm.fabric.citresewn.cit;

import javax.annotation.Nullable;
import net.minecraft.class_1309;
import net.minecraft.class_1772;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1890;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2520;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Objects;

/**
 * Holds momentary information to be used for CITs' condition matching and type effects.
 */
public class CITContext {
    /**
     * The main item stack to check for the CIT.
     */
    public final class_1799 stack;

    /**
     * The item's containing world(defaults to {@link class_310#field_1687} if null)
     */
    public final class_1937 world;

    /**
     * The item's associated living entity if present. (null if not relevant)
     */
    @Nullable
    public final class_1309 entity;

    /**
     * Cached enchantment map from {@link #stack}.
     * @see #enchantments()
     */
    private Map<class_2960, Integer> enchantments = null;

    public CITContext(class_1799 stack, @Nullable class_1937 world, @Nullable class_1309 entity) {
        this.stack = stack;
        this.world = world == null ? class_310.method_1551().field_1687 : world;
        this.entity = entity;
    }

    /**
     * @see #enchantments
     * @return a map of this context item's enchantments
     */
    public Map<class_2960, Integer> enchantments() {
        if (this.enchantments == null) {
            this.enchantments = new LinkedHashMap<>();
            for (class_2520 nbtElement : stack.method_31574(class_1802.field_8598) ? class_1772.method_7806(stack) : stack.method_7921())
                this.enchantments.put(class_1890.method_37427((class_2487) nbtElement), class_1890.method_37424((class_2487) nbtElement));
        }
        return this.enchantments;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof CITContext that &&
                Objects.equals(this.stack, that.stack) &&
                Objects.equals(this.world, that.world) &&
                Objects.equals(this.entity, that.entity);
    }

    @Override
    public int hashCode() {
        return Objects.hash(stack, world, entity);
    }
}
