package shcm.shsupercm.fabric.citresewn.config;

import me.shedaniel.clothconfig2.api.ConfigBuilder;
import me.shedaniel.clothconfig2.api.ConfigCategory;
import me.shedaniel.clothconfig2.api.ConfigEntryBuilder;
import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import net.minecraft.class_437;
import java.util.function.Function;

/**
 * Cloth Config integration to CIT Resewn's config
 * @see CITResewnConfig
 */
public class CITResewnConfigScreenFactory {
    /**
     * Used to get CIT Resewn - Defaults's Cloth Config implementation.
     */
    public static final String DEFAULTS_CONFIG_ENTRYPOINT = "citresewn-defaults:config_screen";

    /**
     * Creates a Cloth Config screen for the current active config instance.
     * @param parent parent to return to from the config screen
     * @return the config screen
     * @throws NoClassDefFoundError if Cloth Config is not present
     */
    public static class_437 create(class_437 parent) {
        CITResewnConfig currentConfig = CITResewnConfig.INSTANCE, defaultConfig = new CITResewnConfig();

        ConfigBuilder builder = ConfigBuilder.create()
                .setParentScreen(parent)
                .setTitle(class_2561.method_43471("config.citresewn.title"))
                .setSavingRunnable(currentConfig::write);

        ConfigCategory category = builder.getOrCreateCategory(class_2561.method_43473());
        ConfigEntryBuilder entryBuilder = builder.entryBuilder();

        category.addEntry(entryBuilder.startBooleanToggle(class_2561.method_43471("config.citresewn.enabled.title"), currentConfig.enabled)
                .setTooltip(class_2561.method_43471("config.citresewn.enabled.tooltip"))
                .setSaveConsumer(newConfig -> {
                    if (currentConfig.enabled != newConfig) {
                        currentConfig.enabled = newConfig;
                        class_310.method_1551().method_1521();
                    }
                })
                .setDefaultValue(defaultConfig.enabled)
                .build());

        if (FabricLoader.getInstance().isModLoaded("citresewn-defaults")) {
            class CurrentScreen { boolean prevToggle = false; } final CurrentScreen currentScreen = new CurrentScreen();
            category.addEntry(entryBuilder.startBooleanToggle(class_2561.method_43471("config.citresewn-defaults.title"), false)
                    .setTooltip(class_2561.method_43471("config.citresewn-defaults.tooltip"))

                    .setYesNoTextSupplier((b) -> {
                        if (b != currentScreen.prevToggle) {
                            //noinspection unchecked
                            class_310.method_1551().method_1507((class_437) FabricLoader.getInstance().getEntrypoints(DEFAULTS_CONFIG_ENTRYPOINT, Function.class).stream().findAny().orElseThrow().apply(create(parent)));

                            currentScreen.prevToggle = b;
                        }

                        return class_2561.method_43471("config.citresewn.configure");
                    })
                    .build());
        }

        category.addEntry(entryBuilder.startBooleanToggle(class_2561.method_43471("config.citresewn.mute_errors.title"), currentConfig.mute_errors)
                .setTooltip(class_2561.method_43471("config.citresewn.mute_errors.tooltip"))
                .setSaveConsumer(newConfig -> currentConfig.mute_errors = newConfig)
                .setDefaultValue(defaultConfig.mute_errors)
                .build());

        category.addEntry(entryBuilder.startBooleanToggle(class_2561.method_43471("config.citresewn.mute_warns.title"), currentConfig.mute_warns)
                .setTooltip(class_2561.method_43471("config.citresewn.mute_warns.tooltip"))
                .setSaveConsumer(newConfig -> currentConfig.mute_warns = newConfig)
                .setDefaultValue(defaultConfig.mute_warns)
                .build());

        category.addEntry(entryBuilder.startIntSlider(class_2561.method_43471("config.citresewn.cache_ms.title"), currentConfig.cache_ms / 50, 0, 5 * 20)
                .setTooltip(class_2561.method_43471("config.citresewn.cache_ms.tooltip"))
                .setSaveConsumer(newConfig -> currentConfig.cache_ms = newConfig * 50)
                .setDefaultValue(defaultConfig.cache_ms / 50)
                .setTextGetter(ticks -> {
                    if (ticks <= 1)
                        return class_2561.method_43471("config.citresewn.cache_ms.ticks." + ticks).method_27692(class_124.field_1075);

                    class_124 color = class_124.field_1079;

                    if (ticks <= 40) color = class_124.field_1061;
                    if (ticks <= 20) color = class_124.field_1065;
                    if (ticks <= 10) color = class_124.field_1077;
                    if (ticks <= 5) color = class_124.field_1060;

                    return class_2561.method_43469("config.citresewn.cache_ms.ticks.any", ticks).method_27692(color);
                })
                .build());

        category.addEntry(entryBuilder.startBooleanToggle(class_2561.method_43471("config.citresewn.broken_paths.title"), currentConfig.broken_paths)
                .setTooltip(class_2561.method_43471("config.citresewn.broken_paths.tooltip"))
                .setSaveConsumer(newConfig -> currentConfig.broken_paths = newConfig)
                .setDefaultValue(defaultConfig.broken_paths)
                .requireRestart()
                .build());

        return builder.build();
    }
}
