package shcm.shsupercm.fabric.citresewn.mixin.broken_paths;

import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import shcm.shsupercm.fabric.citresewn.config.BrokenPaths;

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.zip.ZipFile;
import net.minecraft.class_151;
import net.minecraft.class_2960;
import net.minecraft.class_3255;
import net.minecraft.class_3258;
import net.minecraft.class_3259;
import net.minecraft.class_3262;
import net.minecraft.class_3270;
import net.minecraft.class_3272;

/**
 * Adds a resourcepack compatibility error message when broken paths are enabled and are detected in a pack.
 * @see BrokenPaths
 * @see ResourcePackCompatibilityMixin
 */
@Mixin(class_3255.class)
public abstract class AbstractFileResourcePackMixin implements class_3262 {
    @Shadow @Final protected File base;

    @SuppressWarnings({"unchecked", "ConstantConditions", "EqualsBetweenInconvertibleTypes"})
    @Inject(method = "parseMetadata(Lnet/minecraft/resource/metadata/ResourceMetadataReader;)Ljava/lang/Object;", cancellable = true, at = @At("RETURN"))
    public <T extends class_3272> void citresewn$brokenpaths$parseMetadata(class_3270<T> metaReader, CallbackInfoReturnable<T> cir) {
        if (cir.getReturnValue() != null)
            try {
                if (this.getClass().equals(class_3258.class)) {
                    try (ZipFile zipFile = new ZipFile(base)) {
                        zipFile.stream()
                                .forEach(entry -> {
                                    if (entry.getName().startsWith("assets") && !entry.getName().endsWith(".DS_Store"))
                                        new class_2960("minecraft", entry.getName());
                                });
                    }
                } else if (this.getClass().equals(class_3259.class)) {
                    final Path assets = new File(base, "assets").toPath();
                    Files.walk(assets)
                            .forEach(fullPath -> {
                                String path = assets.relativize(fullPath).toString().replace('\\', '/');
                                if (!path.endsWith(".DS_Store"))
                                    new class_2960("minecraft", path);
                            });
                }
            } catch (class_151 e) {
                cir.setReturnValue((T) new class_3272(cir.getReturnValue().method_14423(), Integer.MAX_VALUE - 53));
            } catch (Exception ignored) {}
    }
}
